﻿/*
* GraphicButton by Grant Skinner. 2004
* Visit www.gskinner.com for documentation, updates and more free code.
*
* You may distribute this code freely, as long as this comment block remains intact.
*/

import mx.events.EventDispatcher;

class com.gskinner.controls.GraphicButton extends MovieClip {
// ui elements:
	private var hitAreaMC:MovieClip;
	private var _enabled:Boolean = true;
	private var _selected:Boolean = false;

// methods for EventDispatcher:
	public var addEventListener:Function;
	public var removeEventListener:Function;
	private var dispatchEvent:Function;

// initialization:
	private function GraphicButton() {
		EventDispatcher.initialize(this);
	}
	private function onLoad() {
		// Force state
		enabled = enabled;
		selected = selected;
		//
		onDragOut = onRollOut;
		onDragOver = onRollOver;
		if (hitAreaMC) { hitArea = hitAreaMC; }
	}

// public methods
	public function get enabled():Boolean { return _enabled; }
	public function set enabled(p_enabled:Boolean):Void {
		_enabled = p_enabled;
		useHandCursor = p_enabled;
		this.gotoAndPlay(enabled ? "up" : "disabled");
	}
	public function get selected():Boolean { return _selected; }
	public function set selected(p_selected:Boolean):Void {
		_selected = p_selected;
		var s:String = (selected) ?  "selected" : (enabled) ? "up" : "disabled";
		this.gotoAndPlay(s);
	}

// private methods
	private function onRollOver(p_dispatch:Boolean):Void {
		if (!enabled) { return; }
		if (p_dispatch == undefined) { dispatchEvent({type:"over"}); }
		if (!selected) { this.gotoAndPlay("over"); }
	}
	private function onRollOut():Void {
		if (!enabled) { return; }
		dispatchEvent({type:"out"});
		if (!selected) {
			this.gotoAndPlay("up"); // in case there is no out state
			this.gotoAndPlay("out");
		}
	}
	private function onPress():Void {
		if (!enabled) { return; }
		dispatchEvent({type:"down"});
		if (!selected) { this.gotoAndPlay("down"); }
	}
	private function onRelease():Void {
		if (!_enabled) { return; }
		dispatchEvent({type:"click"});
		onRollOver(false);
	}
}